CodeForces 666B World Tour【spfa最短路+枚举】

A famous sculptor Cicasso goes to a world tour!

Well, it is not actually a world-wide. But not everyone should have the opportunity to see works of sculptor, shouldn’t he? Otherwise there will be no any exclusivity. So Cicasso will entirely hold the world tour in his native country — Berland.

Cicasso is very devoted to his work and he wants to be distracted as little as possible. Therefore he will visit only four cities. These cities will be different, so no one could think that he has “favourites”. Of course, to save money, he will chose the shortest paths between these cities. But as you have probably guessed, Cicasso is a weird person. Although he doesn’t like to organize exhibitions, he likes to travel around the country and enjoy its scenery. So he wants the total distance which he will travel to be as large as possible. However, the sculptor is bad in planning, so he asks you for help.

There are n cities and m one-way roads in Berland. You have to choose four different cities, which Cicasso will visit and also determine the order in which he will visit them. So that the total distance he will travel, if he visits cities in your order, starting from the first city in your list, and ending in the last, choosing each time the shortest route between a pair of cities — will be the largest.

Note that intermediate routes may pass through the cities, which are assigned to the tour, as well as pass twice through the same city. For example, the tour can look like that: . Four cities in the order of visiting marked as overlines: [1, 5, 2, 4].

Note that Berland is a high-tech country. So using nanotechnologies all roads were altered so that they have the same length. For the same reason moving using regular cars is not very popular in the country, and it can happen that there are such pairs of cities, one of which generally can not be reached by car from the other one. However, Cicasso is very conservative and cannot travel without the car. Choose cities so that the sculptor can make the tour using only the automobile. It is guaranteed that it is always possible to do.

Input
In the first line there is a pair of integers n and m (4 ≤ n ≤ 3000, 3 ≤ m ≤ 5000) — a number of cities and one-way roads in Berland.

Each of the next m lines contains a pair of integers ui, vi (1 ≤ ui, vi ≤ n) — a one-way road from the city ui to the city vi. Note that ui and vi are not required to be distinct. Moreover, it can be several one-way roads between the same pair of cities.

Output
Print four integers — numbers of cities which Cicasso will visit according to optimal choice of the route. Numbers of cities should be printed in the order that Cicasso will visit them. If there are multiple solutions, print any of them.

Example
Input
8 9
1 2
2 3
3 4
4 1
4 5
5 6
6 7
7 8
8 5
Output
2 1 8 7
Note
Let d(x, y) be the shortest distance between cities x and y. Then in the example d(2, 1) = 3, d(1, 8) = 7, d(8, 7) = 3. The total distance equals 13.

题意:n个点m条单向边,让你找四个不同的点,使a->b->c->d的最短路之和最大;
分析:如果按题目模拟,复杂度肯定过不了,之前写过很多的逆向问题,这道题也是逆向边;
枚举bc点,预处理a->b点(也就是逆向边建立b->a)和c->d,n*n复杂度就可以过了。注意:由于点可能会重复,所以预处理保存每个点的最短路的最长点的时候,要保存三个最长点。
之前以为求距离最长,以为不是两点之间的最短路,看了好久的bug;

#include <cstdio>
#include <cstring>
#include <algorithm>
#include <cmath>
#include <queue>
#include <vector>
using namespace std;
typedef long long LL;

const int INF = 0x3f3f3f3f;
const int MAXN = 3000 + 10;
vector<int> G[MAXN], V[MAXN];
int ma[MAXN][MAXN];
int dis_G[4][MAXN], node_G[4][MAXN];
int dis_V[4][MAXN], node_V[4][MAXN];
int vis[MAXN], dis[MAXN], dp[MAXN][MAXN];
int n, m;

int ans1, ans2, ans3;
int st1, st2, st3;

inline void spfa_G(int x) {
    memset(dis, INF, sizeof(dis));
    queue<int> q;
    dis[x] = 0;
    q.push(x);
    while(!q.empty()) {
        int ant = q.front();
        q.pop();
        for(int i = 0; i < G[ant].size(); ++i) {
            int res = dis[ant] + 1;
            if(res < dis[G[ant][i]]) {
                dis[G[ant][i]] = res;
                q.push(G[ant][i]);
            }
        }
    }
    ans1 = 0, ans2 = 0, ans3 = 0;
    st1 = 0, st2 = 0, st3 = 0;
    for(int i = 1; i <= n; i++) {
        if(dis[i] == INF) continue;
        if(dis[i] > ans3) {
            if(dis[i] > ans2) {
                if(dis[i] > ans1) {
                    ans3 = ans2;
                    st3 = st2;
                    ans2 = ans1;
                    st2 = st1;
                    ans1 = dis[i];
                    st1 = i;
                }
                else {
                    ans3 = ans2;
                    st3 = st2;
                    ans2 = dis[i];
                    st2 = i;
                }
            }
            else {
                ans3 = dis[i];
                st3 = i;
            }
        }
    }
}

inline void spfa_V(int x) {
    memset(dis, INF, sizeof(dis));
    queue<int> q;
    dis[x] = 0;
    q.push(x);
    while(!q.empty()) {
        int ant = q.front();
        q.pop();
        for(int i = 0; i < V[ant].size(); ++i) {
            int res = dis[ant] + 1;
            if(res < dis[V[ant][i]]) {
                dis[V[ant][i]] = res;
                q.push(V[ant][i]);
            }
        }
    }
    ans1 = 0, ans2 = 0, ans3 = 0;
    st1 = 0, st2 = 0, st3 = 0;
    for(int i = 1; i <= n; i++) {
        if(dis[i] == INF) continue;
        else if(dis[i] > ans3) {
            if(dis[i] > ans2) {
                if(dis[i] > ans1) {
                    ans3 = ans2;
                    st3 = st2;
                    ans2 = ans1;
                    st2 = st1;
                    ans1 = dis[i];
                    st1 = i;
                }
                else {
                    ans3 = ans2;
                    st3 = st2;
                    ans2 = dis[i];
                    st2 = i;
                }
            }
            else {
                ans3 = dis[i];
                st3 = i;
            }
        }
    }
}

int judge(int i, int j, int p1, int p2) {
    if(!node_V[p1][i] || !node_G[p2][j]) return 0;
    if(node_V[p1][i] != node_G[p2][j] && node_V[p1][i] != j && node_G[p2][j] != i) {
        return (dp[i][j] + dis_V[p1][i] + dis_G[p2][j]);
    }
    else return 0;
}

int main() {
    scanf("%d %d", &n, &m);
    while(m--) {
        int x, y;
        scanf("%d %d", &x, &y);
        if(x == y || ma[x][y]) continue;
        ma[x][y] = 1;
        G[x].push_back(y);
        V[y].push_back(x);
    }
    for(int i = 1; i <= n; ++i) {
        spfa_G(i);
        dis_G[1][i] = ans1, dis_G[2][i] = ans2, dis_G[3][i] = ans3;
        node_G[1][i] = st1, node_G[2][i] = st2, node_G[3][i] = st3;
        spfa_V(i);
        dis_V[1][i] = ans1, dis_V[2][i] = ans2, dis_V[3][i] = ans3;
        node_V[1][i] = st1, node_V[2][i] = st2, node_V[3][i] = st3;
    }
    for(int i = 1; i <= n; ++i) {
        memset(dis, INF, sizeof(dis));
        memset(vis, 0, sizeof(vis));
        spfa_G(i);
        for(int j = 1; j <= n; ++j) {
            dp[i][j] = dis[j];
        }
    }
    int a, b, c, d;
    int sum = 0;
    for(int i = 1; i <= n; ++i) {
        for(int j = 1; j <= n; ++j) {
            if(i == j || dp[i][j] == INF) continue;
            for(int p1 = 1; p1 <= 3; ++p1) {
                for(int p2 = 1; p2 <= 3; ++p2) {
                    int num = judge(i, j, p1, p2);
                    if(num > sum) {
                        sum = num;
                        a = node_V[p1][i];
                        b = i;
                        c = j;
                        d = node_G[p2][j];
                    }
                }
            }
        }
    }
//  printf("@@: %d\n", sum);
    printf("%d %d %d %d\n", a, b, c, d);
    return 0;
}
评论
添加红包

请填写红包祝福语或标题

红包个数最小为10个

红包金额最低5元

当前余额3.43前往充值 >
需支付:10.00
成就一亿技术人!
领取后你会自动成为博主和红包主的粉丝 规则
hope_wisdom
发出的红包
实付
使用余额支付
点击重新获取
扫码支付
钱包余额 0

抵扣说明:

1.余额是钱包充值的虚拟货币,按照1:1的比例进行支付金额的抵扣。
2.余额无法直接购买下载,可以购买VIP、付费专栏及课程。

余额充值